<?php
/*
===========================用户控制器
^^^^^^^^^^^^^^^^^^成员
------添加(on_insert)
------修改(on_update)
------删除(on_del)

*/
class cls_tab_hr_resume_search extends cls_base_table
{
	private $tab_search;
	private $obj_db;
	//构造函数
	function __construct()
	{
		global $obj_db;
		parent::__construct();
		$this->obj_db=$obj_db;
		$this->tab_search=DB_PRE."hr_resume_search";
	}
	/*添加
	arr_fields:关健字数组
	*/
	function on_save($arr_fields,$str_where="")
	{
		$arr_return=array("err"=>"","id"=>0);
		$arr_search=array();
		(!isset($arr_fields["search_id"]))? $arr_fields["search_id"]=0:$arr_fields["search_id"]=intval($arr_fields["search_id"]);
		//格式化数据
		if(!isset($arr_fields["search_name"])||$arr_fields["search_name"]==""){
			$arr_return["err"]="搜索器名称不能为空！";
			return $arr_return;
		}
		//保存操作
		$arr_return=self::chk_search();
		if($arr_return["err"]!="") return $arr_return;
		$lng_id=$arr_fields["search_id"];
		unset($arr_fields["search_id"]);//释放id
		$arr_fields["search_updatetime"]=TIME;
		if($lng_id<1){
			$arr_fields["search_addtime"]=TIME;
			$arr_return=self::_insert($arr_fields);
		}else{
			$str_where="search_id='".$lng_id."'";
			$arr_return=self::_update($arr_fields,$str_where);
			$arr_return["id"]=$lng_id;
		}
		return $arr_return;
	}
	//检查企业是否有使用搜索器的权限
	function chk_search(){
		global $obj_ctl_user,$obj_tab_sys_config;
		$arr_cfg_company=$obj_tab_sys_config->get_model("company");
		$arr_return=array("err"=>"");
		if($obj_ctl_user->type!="company"){
			$arr_return["err"]="您不是企业会员不能添加简历搜索器！";
			return $arr_return;
		}
		//查看企业已经存在搜索器的数量
		$obj_rs   = $this->obj_db->get_one("SELECT count(*) as num FROM ".DB_PRE."hr_resume_search where search_user_id='".$obj_ctl_user->id."'");
		$lng_searchnum=$obj_rs["num"];
		//查看企业是否为VIP会员
		$obj_result = $this->obj_db->query("SELECT company_vip_id,company_vip_time FROM ".DB_PRE."hr_company where company_user_id='".$obj_ctl_user->id."'");
		if($obj_rs = $this->obj_db->fetch_array($obj_result))
		{
			if($obj_rs["company_vip_id"]>0){//VIP类型有效，按VIP设置
				$obj_result2 = $this->obj_db->query("SELECT vip_searchnum,vip_days FROM ".DB_PRE."hr_company_vip where vip_id='".$obj_rs["company_vip_id"]."'");
				if($obj_rs2 = $this->obj_db->fetch_array($obj_result2))
				{
					$lng_time=$obj_rs2["vip_days"]*86400+$obj_rs["company_vip_time"];
					if($lng_time>TIME||$obj_rs2["vip_days"]<1){
						if($obj_rs2["vip_searchnum"]>0&&$obj_rs2["vip_searchnum"]>$lng_searchnum){
							//检测通过，允许发送
							return $arr_return;
						}else if($obj_rs2["vip_searchnum"]<0){
							//不限发布数量，允许发送
							return $arr_return;
						}else{
							//为0，不允许发送
							if($obj_rs2["vip_searchnum"]>0){
								$arr_return["err"]="您的企业所属VIP会员只能添加".$obj_rs2["vip_searchnum"]."个搜索器，请联系工作人员升级";
							}else{
								$arr_return["err"]="您的企业所属VIP会员没有添加搜索器的权限，请联系工作人员升级";
							}
							return $arr_return;
						}
					}else{
						$arr_return["err"]="您的企业所属VIP会员已过期，请联系工作人员！";
						return $arr_return;
					}
				}else{
					$arr_return["err"]="您的企业所属VIP会员已过期，请联系工作人员！";
					return $arr_return;
				}
			}else{//否则按系统默认设置
				if(isset($arr_cfg_company["resume_search_num"])){
					$lng_val=intval($arr_cfg_company["resume_search_num"]);
					if($lng_val>$lng_searchnum){
						return $arr_return;
					}else if($lng_val<0){//小于0，不限发送数量
						return $arr_return;
					}else{
						if($lng_searchnum>0){
							$arr_return["err"]="您没有加入VIP会员，只能添加".$lng_val."个搜索器！";
						}else{
							$arr_return["err"]="您没有添加搜索器的权限，请加入VIP会员吧！";
						}
						return $arr_return;
					}
				}else{
					$arr_return["err"]="您没有添加搜索器的权限，请加入VIP会员吧！";
					return $arr_return;
				}
			}
		}else{
			$arr_return["err"]="您不是企业会员或您没有填写企业必要资料不能添加搜索器！";
			return $arr_return;
		}
	}
	function _insert($arr_fields)
	{
		$arr_return=array("err"=>"","id"=>0);
		if(defined("SYS_OPEN_FZ") && SYS_OPEN_FZ=="1"){
			global $obj_ctl_user;
			$arr_fields["search_fz_id"]=$obj_ctl_user->get_fz_id();
		}
		$arr_return=parent::on_insert($this->tab_search,$arr_fields);
		return $arr_return;
	}
	function _update($arr_fields,$msg_where)
	{
		$arr_return=array("err"=>"","id"=>0);
		$arr_return=parent::on_update($this->tab_search,$arr_fields,$msg_where);
		return $arr_return;
	}
	function on_del($arr_id)
	{
		$arr_return=array("err"=>"");
		$str_id=get_arr_id($arr_id);
		if($str_id==""){
			$arr_return["err"]="没有指定要删除的记录！";
			return $arr_return;
		}
		$arr_return=parent::on_del($this->tab_search,"search_id in(".$str_id.")");

		return $arr_return;
	}
}
?>
